<?php

namespace FireDrum;

if ( !defined( 'ABSPATH' ) ) {
	die();
}

/**
 * Subscribe Box widget class
 */
class Email_Marketing_Widget extends \WP_Widget {
	private $plugin;

	public function __construct() {
		$this->plugin = Email_Marketing_Plugin::instantiate();
		$baseID = Email_Marketing_Plugin::get_branding() === 'firedrum' ? 'Firedrum_Widget' : Email_Marketing_Plugin::get_menu_branding() . '_Email_Marketing_Widget';

		parent::__construct( $baseID, __( Email_Marketing_Plugin::get_menu_branding() . ' Form', Email_Marketing_Plugin::get_textdomain() ), array (
			'description' => __( 'Displays a ' . Email_Marketing_Plugin::get_menu_branding() . ' email opt-in form.', Email_Marketing_Plugin::get_textdomain() )
		) );
	}

	public function widget($args, $instance) {
		if ( !is_array( $instance ) ) {
			$instance = array();
		}

		return $this->plugin->form_shortcode( array_merge( $args, $instance ) );
	}

	public function form($instance) {
		$form_id = !empty( $instance['id'] ) ? $instance['id'] : '';
		$forms = get_posts( array(
			'post_type' => Email_Marketing_Plugin::get_branding() . '-form',
			'post_status' => 'published'
		) );

		require( 'templates/widget-options.php' );
	}

	public function update($new_instance, $old_instance) {
		$instance = array(
			'id' => !empty( $new_instance['id'] ) && is_numeric( $new_instance['id'] ) ? sanitize_text_field( $new_instance['id'] ) : ''
		);

		return $instance;
	}
}
